---
- name: Ensure the c4i name space exists
  tags:
    - prod
    - dev
  k8s:
    state: present
    kubeconfig: "{{ kube_config }}"
    definition:
      api_version: v1
      kind: Namespace
      metadata:
        name: "{{ NAMESPACE }}"
      labels:
        name: "{{ NAMESPACE }}"

- name: Ensure certificate issuer is deployed.
  tags: prod
  k8s:
    state: present
    kubeconfig: "{{ kube_config }}"
    namespace: "{{ NAMESPACE }}"
    definition: "{{ item }}"
  loop: "{{ lookup('template', './deploy/letsencrypt.yaml', wantlist=True) | from_yaml }}"

- name: Ensure c4i-frontend is deployed.
  tags:
    - prod
    - dev
  k8s:
    state: present
    kubeconfig: "{{ kube_config }}"
    namespace: "{{ NAMESPACE }}"
    definition: "{{ item }}"
  loop: "{{ lookup('template', './deploy/kubernetes.yaml', wantlist=True) | from_yaml }}"

- name: Ensure ingress with TLS exists in production
  tags:
    - prod
  k8s:
    state: present
    kubeconfig: "{{ kube_config }}"
    namespace: "{{ NAMESPACE }}"
    definition: "{{ item }}"
  loop: "{{ lookup('template', './deploy/ingress-tls.yaml', wantlist=True) | from_yaml }}"

- name: Ensure ingress without TLS exists in development
  tags:
    - dev
  k8s:
    state: present
    kubeconfig: "{{ kube_config }}"
    namespace: "{{ NAMESPACE }}"
    definition: "{{ item }}"
  loop: "{{ lookup('template', './deploy/ingress.yaml', wantlist=True) | from_yaml }}"
